/* Luigi S - 2024 - StlApps.it */

#include <SoftwareSerial.h>
#include <DFRobotDFPlayerMini.h>

// Pin collegamenti
static const uint8_t PIN_MP3_TX = 13;  // TX Arduino ----- RX module MP3
static const uint8_t PIN_MP3_RX = 11;  // RX Arduino ----- TX module MP3
const int ledPin1 = 9;   // Eye 1
const int ledPin2 = 8;  // Eye 2
const int IRPin = 6;     // IR MH-Sensor

SoftwareSerial softwareSerial(PIN_MP3_RX, PIN_MP3_TX);
DFRobotDFPlayerMini myDFPlayer;

bool motionDetected = false; 
unsigned long animationStartTime = 0;  
const long animationDuration = 13000;   

void setup() {
  Serial.begin(9600);
  
  // PIN
  pinMode(ledPin1, OUTPUT);
  pinMode(ledPin2, OUTPUT);
  pinMode(IRPin, INPUT); 

  //DFPlayer Mini
  softwareSerial.begin(9600);
  
  // Inizializza il modulo MP3
  if (!myDFPlayer.begin(softwareSerial)) {
    Serial.println(F("Errore nell'avviare il lettore MP3."));
    digitalWrite(ledPin1, HIGH); 
    while (true); 
  }
  
  digitalWrite(ledPin1, LOW);  
  Serial.println(F("DFPlayer Mini avviato."));
  myDFPlayer.volume(30);  
  Serial.println(F("Volume impostato a 30."));

  Serial.println(F("Setup completato!"));
}

void loop() {
  // Leggi lo stato del sensore IR
  motionDetected = digitalRead(IRPin);

  
  if (!motionDetected) {
    Serial.println(F("Movimento Rilevato!"));
    

    int track = random(1, 5);  
    myDFPlayer.playMp3Folder(track);
    Serial.print(F("Riproducendo traccia: "));
    Serial.println(track);
    
    animationStartTime = millis();
    
  
    while (millis() - animationStartTime < animationDuration) {
      animateLEDs();  
    }

    digitalWrite(ledPin1, LOW);
    digitalWrite(ledPin2, LOW);
    

    delay(5000);
  } else {
    Serial.println(F("Nessun Movimento"));
  }

  delay(200); 
}

// LED Animation
void animateLEDs() {

  int brightness1 = random(50, 255);  
  int brightness2 = random(50, 255);

  analogWrite(ledPin1, brightness1);
  analogWrite(ledPin2, brightness2);

  delay(random(100, 200));
}